﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TimeScheduler.Common
{
  public static class MathUtil
  {
    public static int IncrementDecrementNumber(string num, int minValue, int maxVal, bool increment)
    {
      int newNum = ValidateNumber(num, minValue, maxVal);
      if (increment)
        newNum = Math.Min(newNum + 1, maxVal);
      else
        newNum = Math.Max(newNum - 1, 0);
      return newNum;
    }

    public static int ValidateNumber(string newNum, int minValue, int maxValue)
    {
      int num;
      if (!int.TryParse(newNum, out num))
        return 0;

      return ValidateNumber(num, minValue, maxValue);
    }

    public static int ValidateNumber(int newNum, int minValue, int maxValue)
    {
      newNum = Math.Max(newNum, minValue);
      newNum = Math.Min(newNum, maxValue);

      return newNum;
    }
  }
}
