﻿using System;
using System.Runtime.Serialization;
using TimeScheduler.Common;

namespace TimeScheduler.Model.Impl
{
  /// <summary>
  /// 
  /// </summary>
  /// <remarks>
  /// <see cref="ISerializable"/> muss implementiert werden, damit die Daten über den BinarFormater serialisiert werden können.
  /// Für den XmlSerializer müsste die Klasse auf Public gestellt werden, was nicht immer gewünscht ist
  /// </remarks>
  [Serializable]
  public class TimeItem : NotifyableObject, ITimeItem//, ISerializable
  {
    public TimeItem() { }

    //#region ISerializable
    //public TimeItem(SerializationInfo info, StreamingContext context)
    //{
    //  Description = (string)info.GetValue("Description", typeof(string));
    //}
    //public void GetObjectData(SerializationInfo info, StreamingContext context)
    //{
    //  info.AddValue("Description", Description, typeof(string));
    //}
    //#endregion

    #region ITimeItem
    private string description_;
    public string Description { get { return description_; } set { SetField(ref description_, value); } }

    private DateTime from_;
    public DateTime From { get { return from_; } set { SetField(ref from_, value); } }

    private DateTime till_;
    public DateTime Till { get { return till_; } set { SetField(ref till_, value); } }

    private int costUnit_;
    public int CostUnit { get { return costUnit_; } set { SetField(ref costUnit_, value); } }

    private TimeItemType itemType_;
    public TimeItemType ItemType { get { return itemType_; } set { SetField(ref itemType_, value); } }
    #endregion
  }
}
